package accrue.analysis.ext;

import java.util.Map;

import polyglot.ast.Eval;
import polyglot.util.SerialVersionUID;
import polyglot.visit.DataFlow;
import polyglot.visit.FlowGraph;
import polyglot.visit.FlowGraph.EdgeKey;
import polyglot.visit.FlowGraph.Peer;
import accrue.analysis.interprocanalysis.DataFlowDispatch;

public class ExtEval extends ExtTerm {
    private static final long serialVersionUID = SerialVersionUID.generate();

    @Override
    public <DFItem extends DataFlow.Item> Map<EdgeKey, DFItem> flowDispatch(
            DataFlowDispatch<DFItem> dataflow, DFItem dfIn,
            FlowGraph<DFItem> graph, Peer<DFItem> peer) {
        Eval n = (Eval) this.node();
        return dataflow.flowEval(n, dfIn, graph, peer);
    }

}
